function D2 = funcD2e(eco,q,B0,display,BG)

theta           = eco.theta;
sigma           = eco.sigma;     % log case
beta            = eco.beta;
lbar            = eco.lbar;      %labor supply when unproductive
alpha           = eco.alpha;      % 
rho             = eco.rho;      % Quarterly value 0.75
phi             = eco.phi;      % productivity scale when excluded
%BG              = eco.BG;


Uc              = eco.Uc;
Ucinv           = eco.Ucinv;
U               = eco.U;

l0              = Ucinv(1/phi)/phi;
Uv              = [U(phi*l0)-l0;U(phi*lbar)-lbar];
M               = [alpha, 1-alpha;1-rho,rho];                       
Wv              = inv(eye(2) - beta*M)*Uv;
We              = Wv(1);
Wu              = Wv(2);


qa              = beta*(alpha + (1-alpha)*Uc(lbar));


c0              = Ucinv(1);
c1              = Ucinv((q./beta - alpha)./(1-alpha));

%c2              = Ucinv( ( ((q./beta - alpha)./(1-alpha)).*q/beta - (1- rho))./rho);
%c3              = Ucinv( (q*Uc(c2)/beta - (1-rho))/rho);
B1              = (B0 - c1+lbar)/((1-rho)*q);
%B2              = B1/q - (c2-lbar)/q;
%B3              = B2/((1-rho)*q) - (c3-lbar)/((1-rho)*q);


 V10             = We;
% V20             = We - B3 + B2;
% V10             = We - B3 + B1;
V00             = We - B1 + B0;

%V3              = U(c3) - lbar + beta*(rho*Wu +(1 - alpha)*V30);
%V2              = U(c2) - lbar + beta*(rho*V3 +(1 - alpha)*V20);
V1              = U(c1) - lbar + beta*(rho*Wu +(1 - rho)*V10);
V10b            = U(c0) - (c0 - B1 + q*B0) + beta*(alpha*V00 + (1-alpha)*V1);

V2 = -10000;
if (lbar + B1 - (1-rho)*q*B1)>0
    V2              = U(lbar + B1 - (1-rho)*q*B1) + beta*(rho*Wu +(1 - rho)*V10);
end;

np              = (1 - rho)/(2-alpha-rho);
FM              = B0 +(1-alpha)*(1 - rho)*B1 + BG/np;



D2.qs       = q;
D2.B0       = B0;
D2.B1       = B1;
D2.V00      = V00;
D2.V10      = V10;
D2.V10b     = V10b;
D2.We       = We;
D2.V1       = V1;
D2.V2       = V2;
D2.Wu       = Wu;
D2.c0       = c0;
D2.c1       = c1;
D2.FM       = FM;

D2.exist = false;
 if B0>B1 && V1>Wu && V2<Wu
     D2.exist = true;
 end;





                                